
#include <windows.h>

/*----- Handle to REPCODER.DLL -------------*/

static HINSTANCE hDLL = 0;

/*----- Pointers to REPCODER.DLL exported functions -------*/

BOOL (WINAPI* ptr_repc_init)(void) = 0;
void (WINAPI* ptr_repc_exit)(void) = 0;

int (WINAPI* ptr_repc_open_report)(HWND, BOOL, const wchar_t*, int, int, const int*, const wchar_t* const*, BOOL, BOOL, BOOL, BOOL, BOOL) = 0;
int (WINAPI* ptr_repc_open_report_a)(HWND, BOOL, const char*, int, int, const int*, const char* const*, BOOL, BOOL, BOOL, BOOL, BOOL) = 0;

int (WINAPI* ptr_repc_open_report2)(HWND, BOOL, const wchar_t*, int, const wchar_t*, BOOL, BOOL, BOOL, BOOL, BOOL) = 0;
int (WINAPI* ptr_repc_open_report2_a)(HWND, BOOL, const char*, int, const char*, BOOL, BOOL, BOOL, BOOL, BOOL) = 0;

int (WINAPI* ptr_repc_call_report)(HWND, BOOL, const wchar_t*, BOOL) = 0;
int (WINAPI* ptr_repc_call_report_a)(HWND, BOOL, const char*, BOOL) = 0;
int (WINAPI* ptr_repc_call_report_param)(HWND, BOOL, const wchar_t*, BOOL, int, const int*, const wchar_t* const*, BOOL) = 0;
int (WINAPI* ptr_repc_call_report_param_a)(HWND, BOOL, const char*, BOOL, int, const int*, const char* const*, BOOL) = 0;

int (WINAPI* ptr_repc_call_report_param2)(HWND, BOOL, const wchar_t*, BOOL, const wchar_t*, BOOL) = 0;
int (WINAPI* ptr_repc_call_report_param2_a)(HWND, BOOL, const char*, BOOL, const char*, BOOL) = 0;

void (WINAPI* ptr_repc_explorer)(HWND, BOOL, const wchar_t*, BOOL, BOOL) = 0;
void (WINAPI* ptr_repc_explorer_a)(HWND, BOOL, const char*, BOOL, BOOL) = 0;
void (WINAPI* ptr_repc_explorer_param)(HWND, BOOL, const wchar_t*, BOOL, BOOL, int, const int*, const wchar_t* const*, BOOL) = 0;
void (WINAPI* ptr_repc_explorer_param_a)(HWND, BOOL, const char*, BOOL, BOOL, int, const int*, const char* const*, BOOL) = 0;

int (WINAPI* ptr_repc_get_report_desc_len)(const wchar_t*) = 0;
int (WINAPI* ptr_repc_get_report_desc_len_a)(const char*) = 0;
BOOL (WINAPI* ptr_repc_get_report_desc)(const wchar_t*, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_repc_get_report_desc_a)(const char*, char*, int) = 0;
const wchar_t* (WINAPI* ptr_repc_alloc_report_desc)(const wchar_t*) = 0;
const char* (WINAPI* ptr_repc_alloc_report_desc_a)(const char*) = 0;
void (WINAPI* ptr_repc_free_memory)(const void*) = 0;

int (WINAPI* ptr_repc_get_open_count)(void) = 0;
BOOL (WINAPI* ptr_repc_can_exit)(void) = 0;

void (WINAPI* ptr_repc_set_user)(const wchar_t*) = 0;
void (WINAPI* ptr_repc_set_user_a)(const char*) = 0;
void (WINAPI* ptr_repc_set_pass)(const wchar_t*) = 0;
void (WINAPI* ptr_repc_set_pass_a)(const char*) = 0;
void (WINAPI* ptr_repc_set_role)(const wchar_t*) = 0;
void (WINAPI* ptr_repc_set_role_a)(const char*) = 0;
void (WINAPI* ptr_repc_set_charset)(const wchar_t*) = 0;
void (WINAPI* ptr_repc_set_charset_a)(const char*) = 0;

void (WINAPI* ptr_repc_set_logo)(const wchar_t*, BOOL) = 0;
void (WINAPI* ptr_repc_set_logo_a)(const char*, BOOL) = 0;

BOOL (WINAPI* ptr_repc_get_demo)(void) = 0;
BOOL (WINAPI* ptr_repc_set_demo)(BOOL) = 0;

void (WINAPI* ptr_repc_set_bde_netdir)(const wchar_t*) = 0;
void (WINAPI* ptr_repc_set_bde_netdir_a)(const char*) = 0;

void (WINAPI* ptr_repc_set_fbclient_thread_safe)(BOOL) = 0;
void (WINAPI* ptr_repc_set_ibclient_thread_safe)(BOOL) = 0;
void (WINAPI* ptr_repc_set_firebird_critical_section)(const CRITICAL_SECTION*) = 0;
void (WINAPI* ptr_repc_set_interbase_critical_section)(const CRITICAL_SECTION*) = 0;

void (WINAPI* ptr_repc_set_external_params_proc)(const void*) = 0;
void (WINAPI* ptr_repc_set_external_params_proc_a)(const void*) = 0;
void (WINAPI* ptr_repc_set_external_params_proc_ex)(const void*) = 0;

void (WINAPI* ptr_repc_set_dialog_fonts)(int) = 0;
void (WINAPI* ptr_repc_set_user_interface_lang)(int) = 0;

BOOL (WINAPI* ptr_repc_create_result)(const wchar_t*, const wchar_t*, const wchar_t*, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_repc_create_result_a)(const char*, const char*, const char*, char*, int) = 0;

BOOL (WINAPI* ptr_repc_create_result_param)(const wchar_t*, const wchar_t*, const wchar_t*, int, const int*, const wchar_t* const*, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_repc_create_result_param_a)(const char*, const char*, const char*, int, const int*, const char* const*, char*, int) = 0;

BOOL (WINAPI* ptr_repc_admin_setup)(BOOL, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, BOOL, BOOL) = 0;
BOOL (WINAPI* ptr_repc_admin_setup_a)(BOOL, const char*, const char*, const char*, const char*, const char*, const char*, const char*, const char*, BOOL, BOOL) = 0;

/* RCALC */
int (WINAPI* ptr_rcalc_alloc_handle)(void) = 0;
int (WINAPI* ptr_rcalc_copy_handle)(int) = 0;
BOOL (WINAPI* ptr_rcalc_free_handle)(int) = 0;
BOOL (WINAPI* ptr_rcalc_free_all_handles)(void) = 0;
int (WINAPI* ptr_rcalc_get_state)(int) = 0;
BOOL (WINAPI* ptr_rcalc_is_valid)(int) = 0;
BOOL (WINAPI* ptr_rcalc_is_compiled)(int) = 0;
BOOL (WINAPI* ptr_rcalc_is_executed)(int) = 0;
void (WINAPI* ptr_rcalc_set_status_window)(int, HWND) = 0;
BOOL (WINAPI* ptr_rcalc_compile)(int, const wchar_t*) = 0;
BOOL (WINAPI* ptr_rcalc_compile_a)(int, const char*) = 0;
BOOL (WINAPI* ptr_rcalc_compile_file)(int, const wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_compile_file_a)(int, const char*, int) = 0;
void (WINAPI* ptr_rcalc_show_error)(HWND) = 0;
int (WINAPI* ptr_rcalc_get_error_text_len)(void) = 0;
BOOL (WINAPI* ptr_rcalc_copy_error_text)(wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_error_text_a)(char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_alloc_error_text)(void) = 0;
const char* (WINAPI* ptr_rcalc_alloc_error_text_a)(void) = 0;
int (WINAPI* ptr_rcalc_get_compiled_text_len)(int, BOOL) = 0;
BOOL (WINAPI* ptr_rcalc_copy_compiled_text)(int, BOOL, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_compiled_text_a)(int, BOOL, char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_compiled_text)(int, BOOL) = 0;
const char* (WINAPI* ptr_rcalc_get_compiled_text_a)(int, BOOL) = 0;
BOOL (WINAPI* ptr_rcalc_execute)(int, int, const wchar_t* const*) = 0;
BOOL (WINAPI* ptr_rcalc_execute_a)(int, int, const char* const*) = 0;
BOOL (WINAPI* ptr_rcalc_execute2)(int, const wchar_t*, const wchar_t*) = 0;
BOOL (WINAPI* ptr_rcalc_execute2_a)(int, const char*, const char*) = 0;

int (WINAPI* ptr_rcalc_get_input_count)(int) = 0;
int (WINAPI* ptr_rcalc_get_input_name_len)(int, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_input_name)(int, int, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_input_name_a)(int, int, char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_input_name)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_input_name_a)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_input_number)(int, wchar_t*) = 0;
int (WINAPI* ptr_rcalc_get_input_number_a)(int, char*) = 0;
int (WINAPI* ptr_rcalc_get_input_type)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_input_type_numscale)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_input_type_name_len)(int, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_input_type_name)(int, int, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_input_type_name_a)(int, int, char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_input_type_name)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_input_type_name_a)(int, int) = 0;

int (WINAPI* ptr_rcalc_get_output_count)(int) = 0;
int (WINAPI* ptr_rcalc_get_output_name_len)(int, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_output_name)(int, int, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_output_name_a)(int, int, char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_output_name)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_output_name_a)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_number)(int, const wchar_t*) = 0;
int (WINAPI* ptr_rcalc_get_output_number_a)(int, const char*) = 0;
int (WINAPI* ptr_rcalc_get_output_type)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_type_textlen)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_type_numscale)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_type_name_len)(int, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_output_type_name)(int, int, wchar_t*, int) = 0;
BOOL (WINAPI* ptr_rcalc_copy_output_type_name_a)(int, int, char*, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_output_type_name)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_output_type_name_a)(int, int) = 0;

BOOL (WINAPI* ptr_rcalc_isnull_input)(int, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_input_string)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_input_string_a)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_input_string_len)(int, int) = 0;
int (WINAPI* ptr_rcalc_copy_input_string)(int, int, wchar_t*, int) = 0;
int (WINAPI* ptr_rcalc_copy_input_string_a)(int, int, char*, int) = 0;
double (WINAPI* ptr_rcalc_get_input_double)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_input_int)(int, int) = 0;
__int64 (WINAPI* ptr_rcalc_get_input_numeric)(int, int) = 0;
__int64 (WINAPI* ptr_rcalc_get_input_time)(int, int) = 0;

BOOL (WINAPI* ptr_rcalc_isnull_output)(int, int) = 0;
const wchar_t* (WINAPI* ptr_rcalc_get_output_string)(int, int) = 0;
const char* (WINAPI* ptr_rcalc_get_output_string_a)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_string_len)(int, int) = 0;
int (WINAPI* ptr_rcalc_copy_output_string)(int, int, wchar_t*, int) = 0;
int (WINAPI* ptr_rcalc_copy_output_string_a)(int, int, char*, int) = 0;
double (WINAPI* ptr_rcalc_get_output_double)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_output_int)(int, int) = 0;
__int64 (WINAPI* ptr_rcalc_get_output_numeric)(int, int) = 0;
__int64 (WINAPI* ptr_rcalc_get_output_time)(int, int) = 0;
int (WINAPI* ptr_rcalc_get_year)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_month)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_day)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_hour)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_minute)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_second)(__int64) = 0;
int (WINAPI* ptr_rcalc_get_millisec)(__int64) = 0;

/* UTILITY */
int (WINAPI* ptr_repc_compress)(unsigned char*, unsigned long*, const unsigned char*, unsigned long) = 0;
int (WINAPI* ptr_repc_uncompress)(unsigned char*, unsigned long*, const unsigned char*, unsigned long) = 0;
HGLOBAL (WINAPI* ptr_repc_load_image)(const wchar_t*) = 0;
HGLOBAL (WINAPI* ptr_repc_load_image_a)(const char*) = 0;
HGLOBAL (WINAPI* ptr_repc_load_image_ptr)(const void*, int) = 0;
HGLOBAL (WINAPI* ptr_repc_convert_image)(const void*, int, int, int) = 0;
HGLOBAL (WINAPI* ptr_repc_shrink_image)(const void*, int, int, int) = 0;
BOOL (WINAPI* ptr_repc_test_connection)(int, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*) = 0;

/*---------------------------------------*/

static int is_repcoder_loaded(void)
{
if( hDLL ) return 1;
else
  {
#ifdef _WIN64
MessageBoxW(0, L"REPCODER64.DLL is not loaded ...\nrepcoder_load() function was not called.", L"REPCoder error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
#else
MessageBoxW(0, L"REPCODER.DLL is not loaded ...\nrepcoder_load() function was not called.", L"REPCoder error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
#endif
   return 0;
  }
}

/*----- definition of functions declared in REPCODER.H -------*/

BOOL WINAPI repc_init()
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_init();
}
/*---------------------------------------*/

void WINAPI repc_exit()
{
if( !is_repcoder_loaded() ) return;
ptr_repc_exit();
}
/*---------------------------------------*/

int WINAPI repc_open_report(
HWND hParent, BOOL bModal, const wchar_t* FormName, int RecordSeqNr,
int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues,
BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
BOOL bAllowDesign, BOOL bAllowUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_open_report(hParent, bModal, FormName, RecordSeqNr,
nParams, pParamsNumbers, pParamsValues,
bParamsUpdate, bRecNavigate, bDesignMode,
bAllowDesign, bAllowUpdate);
}
/*---------------------------------------*/

int WINAPI repc_open_report_a(HWND hParent, BOOL bModal, const char* FormName, int RecordSeqNr,
int nParams, const int* pParamsNumbers, const char* const* pParamsValues,
BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
BOOL bAllowDesign, BOOL bAllowUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_open_report_a(hParent, bModal, FormName, RecordSeqNr,
nParams, pParamsNumbers, pParamsValues,
bParamsUpdate, bRecNavigate, bDesignMode,
bAllowDesign, bAllowUpdate);
}
/*---------------------------------------*/

int WINAPI repc_open_report2(
HWND hParent, BOOL bModal, const wchar_t* FormName, int RecordSeqNr,
const wchar_t* Parameters,
BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
BOOL bAllowDesign, BOOL bAllowUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_open_report2(hParent, bModal, FormName, RecordSeqNr,
Parameters,
bParamsUpdate, bRecNavigate, bDesignMode,
bAllowDesign, bAllowUpdate);
}
/*---------------------------------------*/

int WINAPI repc_open_report2_a(
HWND hParent, BOOL bModal, const char* FormName, int RecordSeqNr,
const char* Parameters,
BOOL bParamsUpdate, BOOL bRecNavigate, BOOL bDesignMode,
BOOL bAllowDesign, BOOL bAllowUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_open_report2_a(hParent, bModal, FormName, RecordSeqNr,
Parameters,
bParamsUpdate, bRecNavigate, bDesignMode,
bAllowDesign, bAllowUpdate);
}
/*---------------------------------------*/

int WINAPI repc_call_report(HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_call_report(hParent, bModal, FormName, bDesignMode);
}
/*---------------------------------------*/

int WINAPI repc_call_report_a(HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_call_report_a(hParent, bModal, FormName, bDesignMode);
}
/*---------------------------------------*/

int WINAPI repc_call_report_param(HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode,
int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_call_report_param(hParent, bModal, FormName, bDesignMode,
nParams, pParamsNumbers, pParamsValues, bParamsUpdate);
}
/*---------------------------------------*/

int WINAPI repc_call_report_param_a(HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode,
int nParams, const int* pParamsNumbers, const char* const* pParamsValues, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_call_report_param_a(hParent, bModal, FormName, bDesignMode,
nParams, pParamsNumbers, pParamsValues, bParamsUpdate);
}
/*---------------------------------------*/

int WINAPI repc_call_report_param2(HWND hParent, BOOL bModal, const wchar_t* FormName, BOOL bDesignMode,
const wchar_t* Parameters, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_call_report_param2(hParent, bModal, FormName, bDesignMode,
Parameters, bParamsUpdate);
}
/*---------------------------------------*/

int WINAPI repc_call_report_param2_a(HWND hParent, BOOL bModal, const char* FormName, BOOL bDesignMode,
const char* Parameters, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return 0;

return ptr_repc_call_report_param2_a(hParent, bModal, FormName, bDesignMode,
Parameters, bParamsUpdate);
}
/*---------------------------------------*/

void WINAPI repc_explorer(HWND hParent, BOOL bModal, const wchar_t* Dir, BOOL bDesign, BOOL bResultOnly)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_explorer(hParent, bModal, Dir, bDesign, bResultOnly);
}
/*---------------------------------------*/

void WINAPI repc_explorer_a(HWND hParent, BOOL bModal, const char* Dir, BOOL bDesign, BOOL bResultOnly)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_explorer_a(hParent, bModal, Dir, bDesign, bResultOnly);
}
/*---------------------------------------*/

void WINAPI repc_explorer_param(HWND hParent, BOOL bModal, const wchar_t* Dir, BOOL bDesign, BOOL bResultOnly,
int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return;

ptr_repc_explorer_param(hParent, bModal, Dir, bDesign, bResultOnly,
nParams, pParamsNumbers, pParamsValues, bParamsUpdate);
}
/*---------------------------------------*/

void WINAPI repc_explorer_param_a(HWND hParent, BOOL bModal, const char* Dir, BOOL bDesign, BOOL bResultOnly,
int nParams, const int* pParamsNumbers, const char* const* pParamsValues, BOOL bParamsUpdate)
{
if( !is_repcoder_loaded() ) return;

ptr_repc_explorer_param_a(hParent, bModal, Dir, bDesign, bResultOnly,
nParams, pParamsNumbers, pParamsValues, bParamsUpdate);
}
/*---------------------------------------*/

int WINAPI repc_get_report_desc_len(const wchar_t* FormName)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_report_desc_len(FormName);
}
/*---------------------------------------*/

int WINAPI repc_get_report_desc_len_a(const char* FormName)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_report_desc_len_a(FormName);
}
/*---------------------------------------*/

const wchar_t* WINAPI repc_alloc_report_desc(const wchar_t* FormName)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_alloc_report_desc(FormName);
}
/*---------------------------------------*/

const char* WINAPI repc_alloc_report_desc_a(const char* FormName)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_alloc_report_desc_a(FormName);
}
/*---------------------------------------*/

void WINAPI repc_free_memory(const void* ptr)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_free_memory(ptr);
}
/*---------------------------------------*/

BOOL WINAPI repc_get_report_desc(const wchar_t* FormName, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_report_desc(FormName, buf, len);
}
/*---------------------------------------*/

BOOL WINAPI repc_get_report_desc_a(const char* FormName, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_report_desc_a(FormName, buf, len);
}
/*---------------------------------------*/

int WINAPI repc_get_open_count()
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_open_count();
}
/*---------------------------------------*/

BOOL WINAPI repc_can_exit()
{
if( !is_repcoder_loaded() ) return 1;
return ptr_repc_can_exit();
}
/*---------------------------------------*/

void WINAPI repc_set_user(const wchar_t* User)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_user(User);
}
/*---------------------------------------*/

void WINAPI repc_set_user_a(const char* User)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_user_a(User);
}
/*---------------------------------------*/

void WINAPI repc_set_pass(const wchar_t* Pass)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_pass(Pass);
}
/*---------------------------------------*/

void WINAPI repc_set_pass_a(const char* Pass)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_pass_a(Pass);
}
/*---------------------------------------*/

void WINAPI repc_set_role(const wchar_t* Role)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_role(Role);
}
/*---------------------------------------*/

void WINAPI repc_set_role_a(const char* Role)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_role_a(Role);
}
/*---------------------------------------*/

void WINAPI repc_set_charset(const wchar_t* CharSet)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_charset(CharSet);
}
/*---------------------------------------*/

void WINAPI repc_set_charset_a(const char* CharSet)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_charset_a(CharSet);
}
/*---------------------------------------*/

void WINAPI repc_set_logo(const wchar_t* szLogo, BOOL bReplace)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_logo(szLogo, bReplace);
}
/*---------------------------------------*/

void WINAPI repc_set_logo_a(const char* szLogo, BOOL bReplace)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_logo_a(szLogo, bReplace);
}
/*---------------------------------------*/

BOOL WINAPI repc_get_demo()
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_get_demo();
}
/*---------------------------------------*/

BOOL WINAPI repc_set_demo(BOOL bDemo)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_set_demo(bDemo);
}
/*---------------------------------------*/

void WINAPI repc_set_bde_netdir(const wchar_t* dir)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_bde_netdir(dir);
}
/*---------------------------------------*/

void WINAPI repc_set_bde_netdir_a(const char* dir)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_bde_netdir_a(dir);
}
/*---------------------------------------*/

void WINAPI repc_set_fbclient_thread_safe(BOOL bSafe)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_fbclient_thread_safe(bSafe);
}
/*---------------------------------------*/

void WINAPI repc_set_ibclient_thread_safe(BOOL bSafe)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_ibclient_thread_safe(bSafe);
}
/*---------------------------------------*/

void WINAPI repc_set_firebird_critical_section(const CRITICAL_SECTION* pCritSec)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_firebird_critical_section(pCritSec);
}
/*---------------------------------------*/

void WINAPI repc_set_interbase_critical_section(const CRITICAL_SECTION* pCritSec)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_interbase_critical_section(pCritSec);
}
/*---------------------------------------*/

void WINAPI repc_set_external_params_proc(const void* pProc)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_external_params_proc(pProc);
}
/*---------------------------------------*/

void WINAPI repc_set_external_params_proc_a(const void* pProc)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_external_params_proc_a(pProc);
}
/*---------------------------------------*/

void WINAPI repc_set_external_params_proc_ex(const void* pProc)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_external_params_proc_ex(pProc);
}
/*---------------------------------------*/

void WINAPI repc_set_dialog_fonts(int Type)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_dialog_fonts(Type);
}
/*---------------------------------------*/

void WINAPI repc_set_user_interface_lang(int Lang)
{
if( !is_repcoder_loaded() ) return;
ptr_repc_set_user_interface_lang(Lang);
}
/*---------------------------------------*/

BOOL WINAPI repc_create_result(const wchar_t* FormName, const wchar_t* ResultName, const wchar_t* ResultDesc, wchar_t* ErrorBuf, int ErrorBufLen)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_create_result(FormName, ResultName, ResultDesc, ErrorBuf, ErrorBufLen);
}
/*---------------------------------------*/

BOOL WINAPI repc_create_result_a(const char* FormName, const char* ResultName, const char* ResultDesc, char* ErrorBuf, int ErrorBufLen)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_create_result_a(FormName, ResultName, ResultDesc, ErrorBuf, ErrorBufLen);
}
/*---------------------------------------*/

BOOL WINAPI repc_create_result_param(const wchar_t* FormName, const wchar_t* ResultName, const wchar_t* ResultDesc, int nParams, const int* pParamsNumbers, const wchar_t* const* pParamsValues, wchar_t* ErrorBuf, int ErrorBufLen)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_create_result_param(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, ErrorBufLen);
}
/*---------------------------------------*/

BOOL WINAPI repc_create_result_param_a(const char* FormName, const char* ResultName, const char* ResultDesc, int nParams, const int* pParamsNumbers, const char* const* pParamsValues, char* ErrorBuf, int ErrorBufLen)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_create_result_param_a(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, ErrorBufLen);
}
/*---------------------------------------*/

BOOL WINAPI repc_admin_setup(BOOL bInterBase, const wchar_t* ConnString, const wchar_t* User, const wchar_t* Pass, const wchar_t* ProjectName, const wchar_t* DbName, const wchar_t* DbLogin, const wchar_t* DbPass, const wchar_t* DbRole, BOOL bVerify, BOOL bShowErrorMess)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_admin_setup(bInterBase, ConnString, User, Pass, ProjectName, DbName, DbLogin, DbPass, DbRole, bVerify, bShowErrorMess);
}
/*---------------------------------------*/

BOOL WINAPI repc_admin_setup_a(BOOL bInterBase, const char* ConnString, const char* User, const char* Pass, const char* ProjectName, const char* DbName, const char* DbLogin, const char* DbPass, const char* DbRole, BOOL bVerify, BOOL bShowErrorMess)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_admin_setup_a(bInterBase, ConnString, User, Pass, ProjectName, DbName, DbLogin, DbPass, DbRole, bVerify, bShowErrorMess);
}
/*---------------------------------------*/

int WINAPI rcalc_alloc_handle(void)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_alloc_handle();
}

int WINAPI rcalc_copy_handle(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_handle(calc_handle);
}

BOOL WINAPI rcalc_free_handle(int calc_handle)
{
if( !hDLL ) return 0;
return ptr_rcalc_free_handle(calc_handle);
}

BOOL WINAPI rcalc_free_all_handles(void)
{
if( !hDLL ) return 0;
return ptr_rcalc_free_all_handles();
}

int WINAPI rcalc_get_state(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_state(calc_handle);
}

BOOL WINAPI rcalc_is_valid(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_is_valid(calc_handle);
}

BOOL WINAPI rcalc_is_compiled(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_is_compiled(calc_handle);
}

BOOL WINAPI rcalc_is_executed(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_is_executed(calc_handle);
}

void WINAPI rcalc_set_status_window(int calc_handle, HWND hStatWnd)
{
if( !is_repcoder_loaded() ) return;
ptr_rcalc_set_status_window(calc_handle, hStatWnd);
}

BOOL WINAPI rcalc_compile(int calc_handle, const wchar_t* pText)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_compile(calc_handle, pText);
}

BOOL WINAPI rcalc_compile_a(int calc_handle, const char* pText)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_compile_a(calc_handle, pText);
}

BOOL WINAPI rcalc_compile_file(int calc_handle, const wchar_t* FileName, int Format)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_compile_file(calc_handle, FileName, Format);
}

BOOL WINAPI rcalc_compile_file_a(int calc_handle, const char* FileName, int Format)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_compile_file_a(calc_handle, FileName, Format);
}

void WINAPI rcalc_show_error(HWND hParent)
{
if( !is_repcoder_loaded() ) return;
ptr_rcalc_show_error(hParent);
}

int WINAPI rcalc_get_error_text_len(void)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_error_text_len();
}

BOOL WINAPI rcalc_copy_error_text(wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_error_text(buf, len);
}

BOOL WINAPI rcalc_copy_error_text_a(char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_error_text_a(buf, len);
}

const wchar_t* WINAPI rcalc_alloc_error_text(void)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_alloc_error_text();
}

const char* WINAPI rcalc_alloc_error_text_a(void)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_alloc_error_text_a();
}

int WINAPI rcalc_get_compiled_text_len(int calc_handle, BOOL bCRLF)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_compiled_text_len(calc_handle, bCRLF);
}

BOOL WINAPI rcalc_copy_compiled_text(int calc_handle, BOOL bCRLF, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_compiled_text(calc_handle, bCRLF, buf, len);
}

BOOL WINAPI rcalc_copy_compiled_text_a(int calc_handle, BOOL bCRLF, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_compiled_text_a(calc_handle, bCRLF, buf, len);
}

const wchar_t* WINAPI rcalc_get_compiled_text(int calc_handle, BOOL bCRLF)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_compiled_text(calc_handle, bCRLF);
}

const char* WINAPI rcalc_get_compiled_text_a(int calc_handle, BOOL bCRLF)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_compiled_text_a(calc_handle, bCRLF);
}

BOOL WINAPI rcalc_execute(int calc_handle, int nInput, const wchar_t* const* pInputValues)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_execute(calc_handle, nInput, pInputValues);
}

BOOL WINAPI rcalc_execute_a(int calc_handle, int nInput, const char* const* pInputValues)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_execute_a(calc_handle, nInput, pInputValues);
}

BOOL WINAPI rcalc_execute2(int calc_handle, const wchar_t* InputValues, const wchar_t* Separator)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_execute2(calc_handle, InputValues, Separator);
}

BOOL WINAPI rcalc_execute2_a(int calc_handle, const char* InputValues, const char* Separator)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_execute2_a(calc_handle, InputValues, Separator);
}

int WINAPI rcalc_get_input_count(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_count(calc_handle);
}

int WINAPI rcalc_get_input_name_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_name_len(calc_handle, number);
}

BOOL WINAPI rcalc_copy_input_name(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_name(calc_handle, number, buf, len);
}

BOOL WINAPI rcalc_copy_input_name_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_name_a(calc_handle, number, buf, len);
}

const wchar_t* WINAPI rcalc_get_input_name(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_input_name(calc_handle, number);
}

const char* WINAPI rcalc_get_input_name_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_input_name_a(calc_handle, number);
}

int WINAPI rcalc_get_input_number(int calc_handle, wchar_t* name)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_number(calc_handle, name);
}

int WINAPI rcalc_get_input_number_a(int calc_handle, char* name)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_number_a(calc_handle, name);
}

int WINAPI rcalc_get_input_type(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_type(calc_handle, number);
}

int WINAPI rcalc_get_input_type_numscale(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_type_numscale(calc_handle, number);
}

int WINAPI rcalc_get_input_type_name_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_type_name_len(calc_handle, number);
}

BOOL WINAPI rcalc_copy_input_type_name(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_type_name(calc_handle, number, buf, len);
}

BOOL WINAPI rcalc_copy_input_type_name_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_type_name_a(calc_handle, number, buf, len);
}

const wchar_t* WINAPI rcalc_get_input_type_name(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_input_type_name(calc_handle, number);
}

const char* WINAPI rcalc_get_input_type_name_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_input_type_name_a(calc_handle, number);
}

int WINAPI rcalc_get_output_count(int calc_handle)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_count(calc_handle);
}

int WINAPI rcalc_get_output_name_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_name_len(calc_handle, number);
}

BOOL WINAPI rcalc_copy_output_name(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_name(calc_handle, number, buf, len);
}

BOOL WINAPI rcalc_copy_output_name_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_name_a(calc_handle, number, buf, len);
}

const wchar_t* WINAPI rcalc_get_output_name(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_output_name(calc_handle, number);
}

const char* WINAPI rcalc_get_output_name_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_output_name_a(calc_handle, number);
}

int WINAPI rcalc_get_output_number(int calc_handle, const wchar_t* name)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_number(calc_handle, name);
}

int WINAPI rcalc_get_output_number_a(int calc_handle, const char* name)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_number_a(calc_handle, name);
}

int WINAPI rcalc_get_output_type(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_type(calc_handle, number);
}

int WINAPI rcalc_get_output_type_textlen(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_type_textlen(calc_handle, number);
}

int WINAPI rcalc_get_output_type_numscale(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_type_numscale(calc_handle, number);
}

int WINAPI rcalc_get_output_type_name_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_type_name_len(calc_handle, number);
}

BOOL WINAPI rcalc_copy_output_type_name(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_type_name(calc_handle, number, buf, len);
}

BOOL WINAPI rcalc_copy_output_type_name_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_type_name_a(calc_handle, number, buf, len);
}

const wchar_t* WINAPI rcalc_get_output_type_name(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_output_type_name(calc_handle, number);
}

const char* WINAPI rcalc_get_output_type_name_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_output_type_name_a(calc_handle, number);
}

BOOL WINAPI rcalc_isnull_input(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 1;
return ptr_rcalc_isnull_input(calc_handle, number);
}

const wchar_t* WINAPI rcalc_get_input_string(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_input_string(calc_handle, number);
}

const char* WINAPI rcalc_get_input_string_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_input_string_a(calc_handle, number);
}

int WINAPI rcalc_get_input_string_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_string_len(calc_handle, number);
}

int WINAPI rcalc_copy_input_string(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_string(calc_handle, number, buf, len);
}

int WINAPI rcalc_copy_input_string_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_input_string_a(calc_handle, number, buf, len);
}

double WINAPI rcalc_get_input_double(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_double(calc_handle, number);
}

int WINAPI rcalc_get_input_int(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_int(calc_handle, number);
}

__int64 WINAPI rcalc_get_input_numeric(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_numeric(calc_handle, number);
}

__int64 WINAPI rcalc_get_input_time(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_input_time(calc_handle, number);
}

BOOL WINAPI rcalc_isnull_output(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 1;
return ptr_rcalc_isnull_output(calc_handle, number);
}

const wchar_t* WINAPI rcalc_get_output_string(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return L"";
return ptr_rcalc_get_output_string(calc_handle, number);
}

const char* WINAPI rcalc_get_output_string_a(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return "";
return ptr_rcalc_get_output_string_a(calc_handle, number);
}

int WINAPI rcalc_get_output_string_len(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_string_len(calc_handle, number);
}

int WINAPI rcalc_copy_output_string(int calc_handle, int number, wchar_t* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_string(calc_handle, number, buf, len);
}

int WINAPI rcalc_copy_output_string_a(int calc_handle, int number, char* buf, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_copy_output_string_a(calc_handle, number, buf, len);
}

double WINAPI rcalc_get_output_double(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_double(calc_handle, number);
}

int WINAPI rcalc_get_output_int(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_int(calc_handle, number);
}

__int64 WINAPI rcalc_get_output_numeric(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_numeric(calc_handle, number);
}

__int64 WINAPI rcalc_get_output_time(int calc_handle, int number)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_output_time(calc_handle, number);
}

int WINAPI rcalc_get_year(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_year(value);
}

int WINAPI rcalc_get_month(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_month(value);
}

int WINAPI rcalc_get_day(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_day(value);
}

int WINAPI rcalc_get_hour(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_hour(value);
}

int WINAPI rcalc_get_minute(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_minute(value);
}

int WINAPI rcalc_get_second(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_second(value);
}

int WINAPI rcalc_get_millisec(__int64 value)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_rcalc_get_millisec(value);
}
/*---------------------------------------*/

int WINAPI repc_compress(unsigned char* a, unsigned long* b, const unsigned char* c, unsigned long d)
{
if( !is_repcoder_loaded() ) return 1;
return ptr_repc_compress(a, b, c, d);
}

int WINAPI repc_uncompress(unsigned char* a, unsigned long* b, const unsigned char* c, unsigned long d)
{
if( !is_repcoder_loaded() ) return 1;
return ptr_repc_uncompress(a, b, c, d);
}

HGLOBAL WINAPI repc_load_image(const wchar_t* fname)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_load_image(fname);
}

HGLOBAL WINAPI repc_load_image_a(const char* fname)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_load_image_a(fname);
}

HGLOBAL WINAPI repc_load_image_ptr(const void* ptr, int len)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_load_image_ptr(ptr, len);
}

HGLOBAL WINAPI repc_convert_image(const void* pSrc, int nSrc, int image_type, int jpg_quality)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_convert_image(pSrc, nSrc, image_type, jpg_quality);
}

HGLOBAL WINAPI repc_shrink_image(const void* pSrc, int nSrc, int dest_len, int dest_len_tolerance)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_shrink_image(pSrc, nSrc, dest_len, dest_len_tolerance);
}

BOOL WINAPI repc_test_connection(int AccessMethod, const wchar_t* ConnStr, const wchar_t* User, const wchar_t* Pass, const wchar_t* Role)
{
if( !is_repcoder_loaded() ) return 0;
return ptr_repc_test_connection(AccessMethod, ConnStr, User, Pass, Role);
}

/*----- Load REPCODER.DLL ------------------*/

HINSTANCE repcoder_load()
{
#ifdef _WIN64
hDLL = LoadLibraryW(L"REPCODER64.DLL");
if( !hDLL )
  {
   MessageBoxW(0, L"Cannot load REPCODER64.DLL ...", L"Error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
   return 0;
  }
#else
hDLL = LoadLibraryW(L"REPCODER.DLL");
if( !hDLL )
  {
   MessageBoxW(0, L"Cannot load REPCODER.DLL ...", L"Error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
   return 0;
  }
#endif

ptr_repc_init = ( BOOL (WINAPI*)(void) ) GetProcAddress(hDLL, "repc_init");
ptr_repc_exit = ( void (WINAPI*)(void) ) GetProcAddress(hDLL, "repc_exit");

ptr_repc_open_report = ( int (WINAPI*)(HWND, BOOL, const wchar_t*, int, int, const int*, const wchar_t* const*, BOOL, BOOL, BOOL, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_open_report");
ptr_repc_open_report_a = ( int (WINAPI*)(HWND, BOOL, const char*, int, int, const int*, const char* const*, BOOL, BOOL, BOOL, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_open_report_a");

ptr_repc_open_report2 = ( int (WINAPI*)(HWND, BOOL, const wchar_t*, int, const wchar_t*, BOOL, BOOL, BOOL, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_open_report2");
ptr_repc_open_report2_a = ( int (WINAPI*)(HWND, BOOL, const char*, int, const char*, BOOL, BOOL, BOOL, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_open_report2_a");

ptr_repc_call_report = ( int (WINAPI*)(HWND, BOOL, const wchar_t*, BOOL) ) GetProcAddress(hDLL, "repc_call_report");
ptr_repc_call_report_a = ( int (WINAPI*)(HWND, BOOL, const char*, BOOL) ) GetProcAddress(hDLL, "repc_call_report_a");
ptr_repc_call_report_param = ( int (WINAPI*)(HWND, BOOL, const wchar_t*, BOOL, int, const int*, const wchar_t* const*, BOOL) ) GetProcAddress(hDLL, "repc_call_report_param");
ptr_repc_call_report_param_a = ( int (WINAPI*)(HWND, BOOL, const char*, BOOL, int, const int*, const char* const*, BOOL) ) GetProcAddress(hDLL, "repc_call_report_param_a");

ptr_repc_call_report_param2 = ( int (WINAPI*)(HWND, BOOL, const wchar_t*, BOOL, const wchar_t*, BOOL) ) GetProcAddress(hDLL, "repc_call_report_param2");
ptr_repc_call_report_param2_a = ( int (WINAPI*)(HWND, BOOL, const char*, BOOL, const char*, BOOL) ) GetProcAddress(hDLL, "repc_call_report_param2_a");

ptr_repc_explorer = ( void (WINAPI*)(HWND, BOOL, const wchar_t*, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_explorer");
ptr_repc_explorer_a = ( void (WINAPI*)(HWND, BOOL, const char*, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_explorer_a");
ptr_repc_explorer_param = ( void (WINAPI*)(HWND, BOOL, const wchar_t*, BOOL, BOOL, int, const int*, const wchar_t* const*, BOOL) ) GetProcAddress(hDLL, "repc_explorer_param");
ptr_repc_explorer_param_a = ( void (WINAPI*)(HWND, BOOL, const char*, BOOL, BOOL, int, const int*, const char* const*, BOOL) ) GetProcAddress(hDLL, "repc_explorer_param_a");

ptr_repc_get_report_desc_len = ( int (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_get_report_desc_len");
ptr_repc_get_report_desc_len_a = ( int (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_get_report_desc_len_a");
ptr_repc_get_report_desc = ( BOOL (WINAPI*)(const wchar_t*, wchar_t*, int) ) GetProcAddress(hDLL, "repc_get_report_desc");
ptr_repc_get_report_desc_a = ( BOOL (WINAPI*)(const char*, char*, int) ) GetProcAddress(hDLL, "repc_get_report_desc_a");
ptr_repc_alloc_report_desc = ( const wchar_t* (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_alloc_report_desc");
ptr_repc_alloc_report_desc_a = ( const char* (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_alloc_report_desc_a");
ptr_repc_free_memory = ( void (WINAPI*)(const void*) ) GetProcAddress(hDLL, "repc_free_memory");

ptr_repc_get_open_count = ( int (WINAPI*)(void) ) GetProcAddress(hDLL, "repc_get_open_count");
ptr_repc_can_exit = ( BOOL (WINAPI*)(void) ) GetProcAddress(hDLL, "repc_can_exit");

ptr_repc_set_user = ( void (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_set_user");
ptr_repc_set_user_a = ( void (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_set_user_a");
ptr_repc_set_pass = ( void (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_set_pass");
ptr_repc_set_pass_a = ( void (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_set_pass_a");
ptr_repc_set_role = ( void (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_set_role");
ptr_repc_set_role_a = ( void (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_set_role_a");
ptr_repc_set_charset = ( void (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_set_charset");
ptr_repc_set_charset_a = ( void (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_set_charset_a");

ptr_repc_set_logo = ( void (WINAPI*)(const wchar_t*, BOOL) ) GetProcAddress(hDLL, "repc_set_logo");
ptr_repc_set_logo_a = ( void (WINAPI*)(const char*, BOOL) ) GetProcAddress(hDLL, "repc_set_logo_a");

ptr_repc_get_demo = ( BOOL (WINAPI*)(void) ) GetProcAddress(hDLL, "repc_get_demo");
ptr_repc_set_demo = ( BOOL (WINAPI*)(BOOL) ) GetProcAddress(hDLL, "repc_set_demo");

ptr_repc_set_bde_netdir = ( void (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_set_bde_netdir");
ptr_repc_set_bde_netdir_a = ( void (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_set_bde_netdir_a");

ptr_repc_set_fbclient_thread_safe = ( void (WINAPI*)(BOOL) ) GetProcAddress(hDLL, "repc_set_fbclient_thread_safe");
ptr_repc_set_ibclient_thread_safe = ( void (WINAPI*)(BOOL) ) GetProcAddress(hDLL, "repc_set_ibclient_thread_safe");
ptr_repc_set_firebird_critical_section = ( void (WINAPI*)(const CRITICAL_SECTION*) ) GetProcAddress(hDLL, "repc_set_firebird_critical_section");
ptr_repc_set_interbase_critical_section = ( void (WINAPI*)(const CRITICAL_SECTION*) ) GetProcAddress(hDLL, "repc_set_interbase_critical_section");

ptr_repc_set_external_params_proc = ( void (WINAPI*)(const void*) ) GetProcAddress(hDLL, "repc_set_external_params_proc");
ptr_repc_set_external_params_proc_a = ( void (WINAPI*)(const void*) ) GetProcAddress(hDLL, "repc_set_external_params_proc_a");
ptr_repc_set_external_params_proc_ex = ( void (WINAPI*)(const void*) ) GetProcAddress(hDLL, "repc_set_external_params_proc_ex");

ptr_repc_set_dialog_fonts = ( void (WINAPI*)(int) ) GetProcAddress(hDLL, "repc_set_dialog_fonts");
ptr_repc_set_user_interface_lang = ( void (WINAPI*)(int) ) GetProcAddress(hDLL, "repc_set_user_interface_lang");

ptr_repc_create_result = ( BOOL (WINAPI*)(const wchar_t*, const wchar_t*, const wchar_t*, wchar_t*, int) ) GetProcAddress(hDLL, "repc_create_result");
ptr_repc_create_result_a = ( BOOL (WINAPI*)(const char*, const char*, const char*, char*, int) ) GetProcAddress(hDLL, "repc_create_result_a");

ptr_repc_create_result_param = ( BOOL (WINAPI*)(const wchar_t*, const wchar_t*, const wchar_t*, int, const int*, const wchar_t* const*, wchar_t*, int) ) GetProcAddress(hDLL, "repc_create_result_param");
ptr_repc_create_result_param_a = ( BOOL (WINAPI*)(const char*, const char*, const char*, int, const int*, const char* const*, char*, int) ) GetProcAddress(hDLL, "repc_create_result_param_a");

ptr_repc_admin_setup = ( BOOL (WINAPI*)(BOOL, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_admin_setup");
ptr_repc_admin_setup_a = ( BOOL (WINAPI*)(BOOL, const char*, const char*, const char*, const char*, const char*, const char*, const char*, const char*, BOOL, BOOL) ) GetProcAddress(hDLL, "repc_admin_setup_a");

/* RCALC */
ptr_rcalc_alloc_handle = ( int (WINAPI*)(void) ) GetProcAddress(hDLL, "rcalc_alloc_handle");
ptr_rcalc_copy_handle = ( int (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_copy_handle");
ptr_rcalc_free_handle = ( BOOL (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_free_handle");
ptr_rcalc_free_all_handles = ( BOOL (WINAPI*)(void) ) GetProcAddress(hDLL, "rcalc_free_all_handles");
ptr_rcalc_get_state = ( int (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_get_state");
ptr_rcalc_is_valid = ( BOOL (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_is_valid");
ptr_rcalc_is_compiled = ( BOOL (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_is_compiled");
ptr_rcalc_is_executed = ( BOOL (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_is_executed");
ptr_rcalc_set_status_window = ( void (WINAPI*)(int, HWND) ) GetProcAddress(hDLL, "rcalc_set_status_window");
ptr_rcalc_compile = ( BOOL (WINAPI*)(int, const wchar_t*) ) GetProcAddress(hDLL, "rcalc_compile");
ptr_rcalc_compile_a = ( BOOL (WINAPI*)(int, const char*) ) GetProcAddress(hDLL, "rcalc_compile_a");
ptr_rcalc_compile_file = ( BOOL (WINAPI*)(int, const wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_compile_file");
ptr_rcalc_compile_file_a = ( BOOL (WINAPI*)(int, const char*, int) ) GetProcAddress(hDLL, "rcalc_compile_file_a");
ptr_rcalc_show_error = ( void (WINAPI*)(HWND) ) GetProcAddress(hDLL, "rcalc_show_error");
ptr_rcalc_get_error_text_len = ( int (WINAPI*)(void) ) GetProcAddress(hDLL, "rcalc_get_error_text_len");
ptr_rcalc_copy_error_text = ( BOOL (WINAPI*)(wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_error_text");
ptr_rcalc_copy_error_text_a = ( BOOL (WINAPI*)(char*, int) ) GetProcAddress(hDLL, "rcalc_copy_error_text_a");
ptr_rcalc_alloc_error_text = ( const wchar_t* (WINAPI*)(void) ) GetProcAddress(hDLL, "rcalc_alloc_error_text");
ptr_rcalc_alloc_error_text_a = ( const char* (WINAPI*)(void) ) GetProcAddress(hDLL, "rcalc_alloc_error_text_a");
ptr_rcalc_get_compiled_text_len = ( int (WINAPI*)(int, BOOL) ) GetProcAddress(hDLL, "rcalc_get_compiled_text_len");
ptr_rcalc_copy_compiled_text = ( BOOL (WINAPI*)(int, BOOL, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_compiled_text");
ptr_rcalc_copy_compiled_text_a = ( BOOL (WINAPI*)(int, BOOL, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_compiled_text_a");
ptr_rcalc_get_compiled_text = ( const wchar_t* (WINAPI*)(int, BOOL) ) GetProcAddress(hDLL, "rcalc_get_compiled_text");
ptr_rcalc_get_compiled_text_a = ( const char* (WINAPI*)(int, BOOL) ) GetProcAddress(hDLL, "rcalc_get_compiled_text_a");
ptr_rcalc_execute = ( BOOL (WINAPI*)(int, int, const wchar_t* const*) ) GetProcAddress(hDLL, "rcalc_execute");
ptr_rcalc_execute_a = ( BOOL (WINAPI*)(int, int, const char* const*) ) GetProcAddress(hDLL, "rcalc_execute_a");
ptr_rcalc_execute2 = ( BOOL (WINAPI*)(int, const wchar_t*, const wchar_t*) ) GetProcAddress(hDLL, "rcalc_execute2");
ptr_rcalc_execute2_a = ( BOOL (WINAPI*)(int, const char*, const char*) ) GetProcAddress(hDLL, "rcalc_execute2_a");

ptr_rcalc_get_input_count = ( int (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_get_input_count");
ptr_rcalc_get_input_name_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_name_len");
ptr_rcalc_copy_input_name = ( BOOL (WINAPI*)(int, int, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_name");
ptr_rcalc_copy_input_name_a = ( BOOL (WINAPI*)(int, int, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_name_a");
ptr_rcalc_get_input_name = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_name");
ptr_rcalc_get_input_name_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_name_a");
ptr_rcalc_get_input_number = ( int (WINAPI*)(int, wchar_t*) ) GetProcAddress(hDLL, "rcalc_get_input_number");
ptr_rcalc_get_input_number_a = ( int (WINAPI*)(int, char*) ) GetProcAddress(hDLL, "rcalc_get_input_number_a");
ptr_rcalc_get_input_type = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_type");
ptr_rcalc_get_input_type_numscale = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_type_numscale");
ptr_rcalc_get_input_type_name_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_type_name_len");
ptr_rcalc_copy_input_type_name = ( BOOL (WINAPI*)(int, int, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_type_name");
ptr_rcalc_copy_input_type_name_a = ( BOOL (WINAPI*)(int, int, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_type_name_a");
ptr_rcalc_get_input_type_name = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_type_name");
ptr_rcalc_get_input_type_name_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_type_name_a");

ptr_rcalc_get_output_count = ( int (WINAPI*)(int) ) GetProcAddress(hDLL, "rcalc_get_output_count");
ptr_rcalc_get_output_name_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_name_len");
ptr_rcalc_copy_output_name = ( BOOL (WINAPI*)(int, int , wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_name");
ptr_rcalc_copy_output_name_a = ( BOOL (WINAPI*)(int, int , char*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_name_a");
ptr_rcalc_get_output_name = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_name");
ptr_rcalc_get_output_name_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_name_a");
ptr_rcalc_get_output_number = ( int (WINAPI*)(int, const wchar_t*) ) GetProcAddress(hDLL, "rcalc_get_output_number");
ptr_rcalc_get_output_number_a = ( int (WINAPI*)(int, const char*) ) GetProcAddress(hDLL, "rcalc_get_output_number_a");
ptr_rcalc_get_output_type = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type");
ptr_rcalc_get_output_type_textlen = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type_textlen");
ptr_rcalc_get_output_type_numscale = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type_numscale");
ptr_rcalc_get_output_type_name_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type_name_len");
ptr_rcalc_copy_output_type_name = ( BOOL (WINAPI*)(int, int, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_type_name");
ptr_rcalc_copy_output_type_name_a = ( BOOL (WINAPI*)(int, int, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_type_name_a");
ptr_rcalc_get_output_type_name = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type_name");
ptr_rcalc_get_output_type_name_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_type_name_a");

ptr_rcalc_isnull_input = ( BOOL (WINAPI*)(int, int) )GetProcAddress(hDLL, "rcalc_isnull_input");
ptr_rcalc_get_input_string = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_string");
ptr_rcalc_get_input_string_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_string_a");
ptr_rcalc_get_input_string_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_string_len");
ptr_rcalc_copy_input_string = ( int (WINAPI*)(int, int, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_string");
ptr_rcalc_copy_input_string_a = ( int (WINAPI*)(int, int, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_input_string_a");
ptr_rcalc_get_input_double = ( double (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_double");
ptr_rcalc_get_input_int = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_int");
ptr_rcalc_get_input_numeric = ( __int64 (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_numeric");
ptr_rcalc_get_input_time = ( __int64 (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_input_time");

ptr_rcalc_isnull_output = ( BOOL (WINAPI*)(int, int) )GetProcAddress(hDLL, "rcalc_isnull_output");
ptr_rcalc_get_output_string = ( const wchar_t* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_string");
ptr_rcalc_get_output_string_a = ( const char* (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_string_a");
ptr_rcalc_get_output_string_len = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_string_len");
ptr_rcalc_copy_output_string = ( int (WINAPI*)(int, int, wchar_t*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_string");
ptr_rcalc_copy_output_string_a = ( int (WINAPI*)(int, int, char*, int) ) GetProcAddress(hDLL, "rcalc_copy_output_string_a");
ptr_rcalc_get_output_double = ( double (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_double");
ptr_rcalc_get_output_int = ( int (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_int");
ptr_rcalc_get_output_numeric = ( __int64 (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_numeric");
ptr_rcalc_get_output_time = ( __int64 (WINAPI*)(int, int) ) GetProcAddress(hDLL, "rcalc_get_output_time");
ptr_rcalc_get_year = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_year");
ptr_rcalc_get_month = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_month");
ptr_rcalc_get_day = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_day");
ptr_rcalc_get_hour = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_hour");
ptr_rcalc_get_minute = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_minute");
ptr_rcalc_get_second = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_second");
ptr_rcalc_get_millisec = ( int (WINAPI*)(__int64) ) GetProcAddress(hDLL, "rcalc_get_millisec");

/* UTILITY */
ptr_repc_compress = ( int (WINAPI*)(unsigned char*, unsigned long*, const unsigned char*, unsigned long) ) GetProcAddress(hDLL, "repc_compress");
ptr_repc_uncompress = ( int (WINAPI*)(unsigned char*, unsigned long*, const unsigned char*, unsigned long) ) GetProcAddress(hDLL, "repc_uncompress");
ptr_repc_load_image = ( HGLOBAL (WINAPI*)(const wchar_t*) ) GetProcAddress(hDLL, "repc_load_image");
ptr_repc_load_image_a = ( HGLOBAL (WINAPI*)(const char*) ) GetProcAddress(hDLL, "repc_load_image_a");
ptr_repc_load_image_ptr = ( HGLOBAL (WINAPI*)(const void*, int) ) GetProcAddress(hDLL, "repc_load_image_ptr");
ptr_repc_convert_image = ( HGLOBAL (WINAPI*)(const void*, int, int, int) ) GetProcAddress(hDLL, "repc_convert_image");
ptr_repc_shrink_image = ( HGLOBAL (WINAPI*)(const void*, int, int, int) ) GetProcAddress(hDLL, "repc_shrink_image");
ptr_repc_test_connection = ( BOOL (WINAPI*)(int, const wchar_t*, const wchar_t*, const wchar_t*, const wchar_t*) ) GetProcAddress(hDLL, "repc_test_connection");

if(
ptr_repc_init &&
ptr_repc_exit &&
ptr_repc_open_report && ptr_repc_open_report_a &&
ptr_repc_call_report && ptr_repc_call_report_a &&
ptr_repc_call_report_param && ptr_repc_call_report_param_a &&
ptr_repc_explorer && ptr_repc_explorer_a &&
ptr_repc_explorer_param && ptr_repc_explorer_param_a &&
ptr_repc_get_report_desc && ptr_repc_get_report_desc_a &&
ptr_repc_get_report_desc_len && ptr_repc_get_report_desc_len_a &&
ptr_repc_alloc_report_desc && ptr_repc_alloc_report_desc_a &&
ptr_repc_free_memory &&
ptr_repc_get_open_count &&
ptr_repc_can_exit &&
ptr_repc_set_user && ptr_repc_set_user_a &&
ptr_repc_set_pass && ptr_repc_set_pass_a &&
ptr_repc_set_role && ptr_repc_set_role_a &&
ptr_repc_set_charset && ptr_repc_set_charset_a &&
ptr_repc_set_logo && ptr_repc_set_logo_a &&
ptr_repc_get_demo &&
ptr_repc_set_demo &&
ptr_repc_set_bde_netdir && ptr_repc_set_bde_netdir_a &&
ptr_repc_set_fbclient_thread_safe &&
ptr_repc_set_ibclient_thread_safe &&
ptr_repc_set_firebird_critical_section &&
ptr_repc_set_interbase_critical_section &&
ptr_repc_set_external_params_proc && ptr_repc_set_external_params_proc_a &&
ptr_repc_set_external_params_proc_ex &&
ptr_repc_set_dialog_fonts &&
ptr_repc_set_user_interface_lang &&
ptr_repc_create_result && ptr_repc_create_result_a &&
ptr_repc_create_result_param && ptr_repc_create_result_param_a &&
ptr_repc_admin_setup && ptr_repc_admin_setup_a &&
ptr_repc_open_report2 && ptr_repc_open_report2_a &&
ptr_repc_call_report_param2 && ptr_repc_call_report_param2_a &&

ptr_repc_compress &&
ptr_repc_uncompress &&
ptr_repc_load_image && ptr_repc_load_image_a &&
ptr_repc_load_image_ptr &&
ptr_repc_convert_image &&
ptr_repc_shrink_image &&
ptr_repc_test_connection &&

ptr_rcalc_alloc_handle &&
ptr_rcalc_copy_handle &&
ptr_rcalc_free_handle &&
ptr_rcalc_free_all_handles &&
ptr_rcalc_get_state &&
ptr_rcalc_is_valid &&
ptr_rcalc_is_compiled &&
ptr_rcalc_is_executed &&
ptr_rcalc_set_status_window &&
ptr_rcalc_compile && ptr_rcalc_compile_a &&
ptr_rcalc_compile_file && ptr_rcalc_compile_file_a &&
ptr_rcalc_show_error &&
ptr_rcalc_get_error_text_len &&
ptr_rcalc_copy_error_text && ptr_rcalc_copy_error_text_a &&
ptr_rcalc_alloc_error_text && ptr_rcalc_alloc_error_text_a &&
ptr_rcalc_get_compiled_text_len &&
ptr_rcalc_copy_compiled_text && ptr_rcalc_copy_compiled_text_a &&
ptr_rcalc_get_compiled_text && ptr_rcalc_get_compiled_text_a &&
ptr_rcalc_execute && ptr_rcalc_execute_a &&
ptr_rcalc_execute2 && ptr_rcalc_execute2_a &&

ptr_rcalc_get_input_count &&
ptr_rcalc_get_input_name_len &&
ptr_rcalc_copy_input_name &&
ptr_rcalc_copy_input_name_a &&
ptr_rcalc_get_input_name &&
ptr_rcalc_get_input_name_a &&
ptr_rcalc_get_input_number &&
ptr_rcalc_get_input_number_a &&
ptr_rcalc_get_input_type &&
ptr_rcalc_get_input_type_numscale &&
ptr_rcalc_get_input_type_name_len &&
ptr_rcalc_copy_input_type_name &&
ptr_rcalc_copy_input_type_name_a &&
ptr_rcalc_get_input_type_name &&
ptr_rcalc_get_input_type_name_a &&

ptr_rcalc_get_output_count &&
ptr_rcalc_get_output_name_len &&
ptr_rcalc_copy_output_name && ptr_rcalc_copy_output_name_a &&
ptr_rcalc_get_output_name && ptr_rcalc_get_output_name_a &&
ptr_rcalc_get_output_number && ptr_rcalc_get_output_number_a &&
ptr_rcalc_get_output_type &&
ptr_rcalc_get_output_type_textlen &&
ptr_rcalc_get_output_type_numscale &&
ptr_rcalc_get_output_type_name_len &&
ptr_rcalc_copy_output_type_name && ptr_rcalc_copy_output_type_name_a &&
ptr_rcalc_get_output_type_name && ptr_rcalc_get_output_type_name_a &&

ptr_rcalc_isnull_input &&
ptr_rcalc_get_input_string && ptr_rcalc_get_input_string_a &&
ptr_rcalc_get_input_string_len &&
ptr_rcalc_copy_input_string && ptr_rcalc_copy_input_string_a &&
ptr_rcalc_get_input_double &&
ptr_rcalc_get_input_int &&
ptr_rcalc_get_input_numeric &&
ptr_rcalc_get_input_time &&

ptr_rcalc_isnull_output &&
ptr_rcalc_get_output_string && ptr_rcalc_get_output_string_a &&
ptr_rcalc_get_output_string_len &&
ptr_rcalc_copy_output_string && ptr_rcalc_copy_output_string_a &&
ptr_rcalc_get_output_double &&
ptr_rcalc_get_output_int &&
ptr_rcalc_get_output_numeric &&
ptr_rcalc_get_output_time &&
ptr_rcalc_get_year &&
ptr_rcalc_get_month &&
ptr_rcalc_get_day &&
ptr_rcalc_get_hour &&
ptr_rcalc_get_minute &&
ptr_rcalc_get_second &&
ptr_rcalc_get_millisec
) return hDLL;

FreeLibrary(hDLL);
hDLL = 0;

#ifdef _WIN64
MessageBoxW(0, L"Cannot find some exported functions of REPCODER64.DLL ...", L"REPCoder error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
#else
MessageBoxW(0, L"Cannot find some exported functions of REPCODER.DLL ...", L"REPCoder error", MB_OK|MB_ICONEXCLAMATION|MB_TASKMODAL|MB_SETFOREGROUND);
#endif

return 0;
}

/*----- Free REPCODER.DLL ------------------*/

void repcoder_free()
{
if( hDLL )
  {
   FreeLibrary(hDLL);
   hDLL = 0;
  }
}

